<?xml version="1.0" encoding="UTF-8"?>

<!--
	* Licensed Materials - Property of IBM
	* 5724-C11, 5724-C13, 5724-D17
	* (C) Copyright IBM Corporation 1997, 2003. All Rights Reserved.
	* US Government Users Restricted Rights- Use, duplication or disclosure
	* restricted by GSA ADP Schedule Contract with IBM Corp.
-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:fo="http://www.w3.org/1999/XSL/Format" xmlns:tns="http://tempuri.org/cwld2bpel/wsdl" xmlns:slt="http://schemas.xmlsoap.org/ws/2002/06/service-link/" xmlns:cwld="http://www.ibm.com/cwld" xmlns:xsd="http://www.w3.org/2001/XMLSchema"  
xmlns:xalan="http://xml.apache.org/xalan" extension-element-prefixes="xalan">

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the BO definitions 
	Assumption : Each BusinessObjType also corresponds to a message.
	match Scenario
	***************************************************************************************************************************************************************************
-->

	<xsl:template match="/">
		<xsl:element name="definitions" namespace="http://schemas.xmlsoap.org/wsdl/">
			<xsl:attribute name="name"><xsl:value-of select="concat(/CollabTemplate/@Name,'BPEL_WSDL')"></xsl:value-of></xsl:attribute>
			<xsl:attribute name="targetNamespace"><xsl:value-of select="concat(/CollabTemplate/@Name,'BPEL_WSDL')"></xsl:value-of></xsl:attribute>
			<xsl:attribute name="xmlns:tns"><xsl:value-of select="concat(/CollabTemplate/@Name,'BPEL_WSDL')"></xsl:value-of></xsl:attribute>
			<xsl:copy-of select="document('')/*/namespace::tns" />
			<xsl:copy-of select="document('')/*/namespace::slt" />
			<xsl:copy-of select="document('')/*/namespace::cwld" />
			<xsl:copy-of select="document('')/*/namespace::xsd" />
  	             <xsl:for-each select="xalan:distinct(/CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef/@BusObjType)">
				<message>
					<xsl:attribute name="name" ><xsl:value-of select="."/><xsl:text>Msg</xsl:text></xsl:attribute>
					<part>
						<xsl:attribute name="name" ><xsl:value-of select="." /><xsl:text>Info</xsl:text></xsl:attribute>
						<xsl:attribute name="type" ><xsl:text>cwld:</xsl:text><xsl:value-of select="." /></xsl:attribute>
					</part>
				</message>
			</xsl:for-each>
			<xsl:apply-templates select="/CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef" mode="port"/>
			<slt:serviceLinkType>
					<xsl:attribute name="name" ><xsl:value-of select="concat(/CollabTemplate/@Name,'SLT')"></xsl:value-of></xsl:attribute>
							<slt:role>
								<xsl:attribute name="name" ><xsl:value-of select="concat(/CollabTemplate/@Name,'Role')"></xsl:value-of></xsl:attribute>
								<xsl:apply-templates select="/CollabTemplate/TemplateDefinition/BusObjRefs/BusObjRef" mode="servicelinkporttype"/>
							</slt:role>
			</slt:serviceLinkType>
			<service>
				<xsl:attribute name="name" ><xsl:value-of select="concat(/CollabTemplate/@Name,'BPELServiceBP')"></xsl:value-of></xsl:attribute>
			</service>
		</xsl:element>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the portType
	portType.name=/CollabTemplate/Scenarios/Scenario/@Name
	Find the Verb/ScenarioName which equals the porttype.name
	porttype.operation.name=Verb/@Name + BusObjRef/@Name
	porttype.operation.input.name=BusObjRef/@Name + "Input"
	porttype.operation.input.message="wBO:" + BusObjRef/@Name + "Msg"
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="BusObjRef" mode="port">
	<xsl:variable name="found">
		<xsl:choose>
			<xsl:when test="Verbs/Verb[@IsSubscribeEvent='Yes']">true	</xsl:when>
		</xsl:choose>
	</xsl:variable>
		<xsl:if test="boolean(normalize-space($found))">
			<portType>
					<xsl:attribute name="name" ><xsl:value-of select="concat(@Name,'PT')"></xsl:value-of></xsl:attribute>
					<xsl:for-each select="Verbs/Verb">
						<xsl:if test="@IsSubscribeEvent='Yes'">
							<operation>
								<xsl:attribute name="name" ><xsl:value-of select="@Name"></xsl:value-of></xsl:attribute>
								<input>
									<xsl:attribute name="message" ><xsl:value-of select="concat('tns:',../../@BusObjType,'Msg')"></xsl:value-of></xsl:attribute>
								</input>
							</operation>
						</xsl:if>
					</xsl:for-each>
			</portType>
		</xsl:if>
	</xsl:template>

<!-- 
	***************************************************************************************************************************************************************************
	Fills in the serviceLinkType
	***************************************************************************************************************************************************************************
-->
	<xsl:template match="BusObjRef" mode="servicelinkporttype">
	<xsl:variable name="portname"><xsl:value-of select="@Name"></xsl:value-of></xsl:variable>
		<xsl:for-each select="Verbs/Verb[@IsSubscribeEvent='Yes']">
			<xsl:if test="position()=1">
				<slt:portType>
					<xsl:attribute name="name" ><xsl:value-of select="concat('tns:',$portname,'PT')"></xsl:value-of></xsl:attribute>
				</slt:portType>
			</xsl:if>
		</xsl:for-each>
	</xsl:template>


</xsl:stylesheet>
